freedombone-recoverkey 4.9KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177
  1. #!/bin/bash
  2. # _____ _ _
  3. # | __|___ ___ ___ _| |___ _____| |_ ___ ___ ___
  4. # | __| _| -_| -_| . | . | | . | . | | -_|
  5. # |__| |_| |___|___|___|___|_|_|_|___|___|_|_|___|
  6. #
  7. # Freedom in the Cloud
  8. #
  9. # A script which recovers a user's gpg key from a number of fragments
  10. # License
  11. # =======
  12. #
  13. # Copyright (C) 2015-2018 Bob Mottram <bob@freedombone.net>
  14. #
  15. # This program is free software: you can redistribute it and/or modify
  16. # it under the terms of the GNU Affero General Public License as published by
  17. # the Free Software Foundation, either version 3 of the License, or
  18. # (at your option) any later version.
  19. #
  20. # This program is distributed in the hope that it will be useful,
  21. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  22. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  23. # GNU Affero General Public License for more details.
  24. #
  25. # You should have received a copy of the GNU Affero General Public License
  26. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  27. PROJECT_NAME='freedombone'
  28. export TEXTDOMAIN=${PROJECT_NAME}-recoverkey
  29. export TEXTDOMAINDIR="/usr/share/locale"
  30. source "$PROJECT_INSTALL_DIR/${PROJECT_NAME}-vars"
  31. # include utils which allow function_check, go and drive mount
  32. UTILS_FILES="/usr/share/${PROJECT_NAME}/utils/${PROJECT_NAME}-utils-*"
  33. for f in $UTILS_FILES
  34. do
  35. source "$f"
  36. done
  37. FRIENDS_SERVERS_LIST=
  38. MY_USERNAME=
  39. function show_help {
  40. echo ''
  41. echo $"${PROJECT_NAME}-recoverkey -u [username]"
  42. echo $' -l [friends servers list filename]'
  43. echo ''
  44. exit 0
  45. }
  46. while [ $# -gt 1 ]
  47. do
  48. key="$1"
  49. case $key in
  50. -h|--help)
  51. show_help
  52. ;;
  53. -u|--user)
  54. shift
  55. MY_USERNAME="$1"
  56. ;;
  57. # backup list filename
  58. # typically /home/$USER/backup.list
  59. -l|--list)
  60. shift
  61. FRIENDS_SERVERS_LIST="$1"
  62. ;;
  63. *)
  64. # unknown option
  65. ;;
  66. esac
  67. shift
  68. done
  69. if [ ! "$MY_USERNAME" ]; then
  70. show_help
  71. fi
  72. if [ ! -d "/home/$MY_USERNAME" ]; then
  73. echo $"User $MY_USERNAME does not exist on the system"
  74. exit 7270
  75. fi
  76. if [ ! "$MY_USERNAME" ]; then
  77. echo $'No username given'
  78. exit 3578
  79. fi
  80. if [ ! -d "/home/$MY_USERNAME" ]; then
  81. echo $"User $MY_USERNAME does not exist on the system"
  82. exit 7270
  83. fi
  84. FRAGMENTS_DIR="/home/$MY_USERNAME/.gnupg_fragments"
  85. # if no remote backup list was given then assume recover from USB
  86. if [ ! "$FRIENDS_SERVERS_LIST" ]; then
  87. interactive_gpg_from_usb
  88. exit 0
  89. fi
  90. # obtain shares/fragments from remote locations
  91. if [ "$FRIENDS_SERVERS_LIST" ]; then
  92. # For each remote server
  93. while read -r remote_server
  94. do
  95. # Get the server and its password
  96. # Format is:
  97. # username@domain:/home/username <port number> <ssh password>
  98. REMOTE_SERVER=$(echo "${remote_server}" | awk -F ' ' '{print $1}')
  99. if [ "$REMOTE_SERVER" ]; then
  100. REMOTE_SSH_PORT=$(echo "${remote_server}" | awk -F ' ' '{print $2}')
  101. REMOTE_PASSWORD=$(echo "${remote_server}" | awk -F ' ' '{print $3}')
  102. # create a directory if it doesn't exist
  103. if [ ! -d "/home/$MY_USERNAME/.gnupg_fragments" ]; then
  104. mkdir -p "/home/$MY_USERNAME/.gnupg_fragments"
  105. fi
  106. echo -n $"Starting key retrieval from $REMOTE_SERVER..."
  107. /usr/bin/sshpass -p "$REMOTE_PASSWORD" \
  108. scp -r -P "$REMOTE_SSH_PORT" "$REMOTE_SERVER/.gnupg_fragments/"* "/home/$MY_USERNAME/.gnupg_fragments"
  109. # shellcheck disable=SC2181
  110. if [ ! "$?" = "0" ]; then
  111. echo $'FAILED'
  112. else
  113. echo $'Ok'
  114. fi
  115. fi
  116. done < "$FRIENDS_SERVERS_LIST"
  117. fi
  118. # was a directory created?
  119. if [ ! -d "$FRAGMENTS_DIR" ]; then
  120. echo $'No fragments have been recovered, so the key cannot be recovered'
  121. exit 7483
  122. fi
  123. # was anything downloaded?
  124. cd "$FRAGMENTS_DIR" || exit 24682468
  125. # shellcheck disable=SC2012
  126. no_of_shares=$(ls -afq keyshare.asc.* | wc -l)
  127. if (( no_of_shares == 0 )); then
  128. echo $'No key fragments were retrieved'
  129. exit 76882
  130. fi
  131. # set permissions on the fragments
  132. chown -R "$MY_USERNAME":"$MY_USERNAME" "/home/$MY_USERNAME/.gnupg_fragments"
  133. # decrypt the file
  134. KEYS_FILE=$FRAGMENTS_DIR/keyshare.asc
  135. cd "$FRAGMENTS_DIR" || exit 482746874624
  136. gfcombine "$KEYS_FILE.*"
  137. if [ ! -f "$KEYS_FILE" ]; then
  138. echo $'Unable to decrypt key. This may mean that not enough fragments are available'
  139. exit 6283
  140. fi
  141. echo $'Key fragments recombined'
  142. # import the gpg key
  143. if ! gpg --homedir="/home/$MY_USERNAME/.gnupg" --allow-secret-key-import --import "$KEYS_FILE"; then
  144. echo $'Unable to import gpg key'
  145. rm "$KEYS_FILE"
  146. exit 3682
  147. fi
  148. rm "$KEYS_FILE"
  149. chown -R "$MY_USERNAME":"$MY_USERNAME" "/home/$MY_USERNAME/.gnupg"
  150. chmod -R 600 "/home/$MY_USERNAME/.gnupg"
  151. echo $'GPG key was recovered'
  152. exit 0